/* ***********************************************************
 * This file was automatically generated on 2012-12-20.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for high precision sensing of voltage and current
	/// </summary>
	public class BrickletVoltageCurrent : Device 
	{
		private static byte FUNCTION_GET_CURRENT = 1;
		private static byte FUNCTION_GET_VOLTAGE = 2;
		private static byte FUNCTION_GET_POWER = 3;
		private static byte FUNCTION_SET_CONFIGURATION = 4;
		private static byte FUNCTION_GET_CONFIGURATION = 5;
		private static byte FUNCTION_SET_CALIBRATION = 6;
		private static byte FUNCTION_GET_CALIBRATION = 7;
		private static byte FUNCTION_SET_CURRENT_CALLBACK_PERIOD = 8;
		private static byte FUNCTION_GET_CURRENT_CALLBACK_PERIOD = 9;
		private static byte FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD = 10;
		private static byte FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD = 11;
		private static byte FUNCTION_SET_POWER_CALLBACK_PERIOD = 12;
		private static byte FUNCTION_GET_POWER_CALLBACK_PERIOD = 13;
		private static byte FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD = 14;
		private static byte FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD = 15;
		private static byte FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD = 16;
		private static byte FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD = 17;
		private static byte FUNCTION_SET_POWER_CALLBACK_THRESHOLD = 18;
		private static byte FUNCTION_GET_POWER_CALLBACK_THRESHOLD = 19;
		private static byte FUNCTION_SET_DEBOUNCE_PERIOD = 20;
		private static byte FUNCTION_GET_DEBOUNCE_PERIOD = 21;
		private static byte CALLBACK_CURRENT = 22;
		private static byte CALLBACK_VOLTAGE = 23;
		private static byte CALLBACK_POWER = 24;
		private static byte CALLBACK_CURRENT_REACHED = 25;
		private static byte CALLBACK_VOLTAGE_REACHED = 26;
		private static byte CALLBACK_POWER_REACHED = 27;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.SetCurrentCallbackPeriod"/>. The parameter is the current of the
		///  sensor.
		///  
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.Current"/> is only triggered if the current has changed since the
		///  last triggering.
		/// </summary>
		public delegate void Current(int current);

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.SetVoltageCallbackPeriod"/>. The parameter is the voltage of the
		///  sensor.
		///  
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.Voltage"/> is only triggered if the voltage has changed since the
		///  last triggering.
		/// </summary>
		public delegate void Voltage(int voltage);

		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.SetPowerCallbackPeriod"/>. The parameter is the power of the
		///  sensor.
		///  
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.Power"/> is only triggered if the power has changed since the
		///  last triggering.
		/// </summary>
		public delegate void Power(int power);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.SetCurrentCallbackThreshold"/> is reached.
		///  The parameter is the current of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletVoltageCurrent.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void CurrentReached(int current);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.SetVoltageCallbackThreshold"/> is reached.
		///  The parameter is the voltage of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletVoltageCurrent.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void VoltageReached(int voltage);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.SetPowerCallbackThreshold"/> is reached.
		///  The parameter is the power of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletVoltageCurrent.SetDebouncePeriod"/>.
		/// </summary>
		public delegate void PowerReached(int power);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletVoltageCurrent(string uid) : base(uid) 
		{
			this.expectedName = "Voltage/Current Bricklet";
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[CALLBACK_CURRENT] = new MessageCallback(CallbackCurrent);
			messageCallbacks[CALLBACK_VOLTAGE] = new MessageCallback(CallbackVoltage);
			messageCallbacks[CALLBACK_POWER] = new MessageCallback(CallbackPower);
			messageCallbacks[CALLBACK_CURRENT_REACHED] = new MessageCallback(CallbackCurrentReached);
			messageCallbacks[CALLBACK_VOLTAGE_REACHED] = new MessageCallback(CallbackVoltageReached);
			messageCallbacks[CALLBACK_POWER_REACHED] = new MessageCallback(CallbackPowerReached);
		}

		/// <summary>
		///  Returns the current. The value is in mA
		///  and between 0mA and 20000mA.
		///  
		///  If you want to get the current periodically, it is recommended to use the
		///  callback <see cref="Tinkerforge.BrickletVoltageCurrent.Current"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.SetCurrentCallbackPeriod"/>.
		/// </summary>
		public int GetCurrent()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CURRENT, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CURRENT, out response);

			return LEConverter.IntFrom(4, response);
		}

		/// <summary>
		///  Returns the voltage. The value is in mV
		///  and between 0mV and 36000mV.
		///  
		///  If you want to get the voltage periodically, it is recommended to use the
		///  callback <see cref="Tinkerforge.BrickletVoltageCurrent.Voltage"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.SetVoltageCallbackPeriod"/>.
		/// </summary>
		public int GetVoltage()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_VOLTAGE, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_VOLTAGE, out response);

			return LEConverter.IntFrom(4, response);
		}

		/// <summary>
		///  Returns the power. The value is in mW
		///  and between 0mV and 720000mW.
		///  
		///  If you want to get the power periodically, it is recommended to use the
		///  callback <see cref="Tinkerforge.BrickletVoltageCurrent.Power"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.SetPowerCallbackPeriod"/>.
		/// </summary>
		public int GetPower()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_POWER, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_POWER, out response);

			return LEConverter.IntFrom(4, response);
		}

		/// <summary>
		///  Sets the configuration of the Voltage/Current Bricklet. It is
		///  possible to configure number of averages as well as
		///  voltage and current conversion time.
		///  
		///  Averaging:
		///  
		///  <code>
		///   "Value", "Number of Averages"
		///  
		///   "0",    "1"
		///   "1",    "4"
		///   "2",    "16"
		///   "3",    "64"
		///   "4",    "128"
		///   "5",    "256"
		///   "6",    "512"
		///   "&gt;=7",  "1024"
		///  </code>
		///  
		///  Voltage/Current conversion:
		///  
		///  <code>
		///   "Value", "Conversion time"
		///  
		///   "0",    "140µs"
		///   "1",    "204µs"
		///   "2",    "332µs"
		///   "3",    "588µs"
		///   "4",    "1.1ms"
		///   "5",    "2.116ms"
		///   "6",    "4.156ms"
		///   "&gt;=7",  "8.244ms"
		///  </code>
		///  
		///  The default values are 3, 4 and 4 (64, 1.1ms, 1.1ms) for averaging, voltage 
		///  conversion and current conversion.
		/// </summary>
		public void SetConfiguration(byte averaging, byte voltageConversionTime, byte currentConversionTime)
		{
			byte[] data_ = new byte[7];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_CONFIGURATION, 1, data_);
			LEConverter.To((ushort)7, 2, data_);
			LEConverter.To(averaging, 4, data_);
			LEConverter.To(voltageConversionTime, 5, data_);
			LEConverter.To(currentConversionTime, 6, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the configuration as set by <see cref="Tinkerforge.BrickletVoltageCurrent.SetConfiguration"/>.
		/// </summary>
		public void GetConfiguration(out byte averaging, out byte voltageConversionTime, out byte currentConversionTime)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CONFIGURATION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CONFIGURATION, out response);

			averaging = LEConverter.ByteFrom(4, response);
			voltageConversionTime = LEConverter.ByteFrom(5, response);
			currentConversionTime = LEConverter.ByteFrom(6, response);
		}

		/// <summary>
		///  Since the shunt resistor that is used to measure the current is not
		///  perfectly precise, it needs to be calibrated by a multiplier and
		///  divisor if a very precise reading is needed.
		///  
		///  For example, if you are expecting a measurement of 1000mA and you
		///  are measuring 1023mA, you can calibrate the Voltage/Current Bricklet 
		///  by setting the multiplier to 1000 and the divisior to 1023.
		/// </summary>
		public void SetCalibration(ushort gainMultiplier, ushort gainDivisor)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_CALIBRATION, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(gainMultiplier, 4, data_);
			LEConverter.To(gainDivisor, 6, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the calibration as set by <see cref="Tinkerforge.BrickletVoltageCurrent.SetCalibration"/>.
		/// </summary>
		public void GetCalibration(out ushort gainMultiplier, out ushort gainDivisor)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CALIBRATION, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CALIBRATION, out response);

			gainMultiplier = LEConverter.UShortFrom(4, response);
			gainDivisor = LEConverter.UShortFrom(6, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletVoltageCurrent.Current"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.Current"/> is only triggered if the current has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetCurrentCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_CURRENT_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletVoltageCurrent.SetCurrentCallbackPeriod"/>.
		/// </summary>
		public uint GetCurrentCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CURRENT_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CURRENT_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletVoltageCurrent.Voltage"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.Voltage"/> is only triggered if the voltage has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetVoltageCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletVoltageCurrent.SetVoltageCallbackPeriod"/>.
		/// </summary>
		public uint GetVoltageCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletVoltageCurrent.Power"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletVoltageCurrent.Power"/> is only triggered if the power has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetPowerCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_POWER_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletVoltageCurrent.GetPowerCallbackPeriod"/>.
		/// </summary>
		public uint GetPowerCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_POWER_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_POWER_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletVoltageCurrent.CurrentReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the current is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the current is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the current is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the current is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetCurrentCallbackThreshold(char option, int min, int max)
		{
			byte[] data_ = new byte[13];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_CURRENT_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)13, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 9, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletVoltageCurrent.SetCurrentCallbackThreshold"/>.
		/// </summary>
		public void GetCurrentCallbackThreshold(out char option, out int min, out int max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_CURRENT_CALLBACK_THRESHOLD, out response);

			option = LEConverter.CharFrom(4, response);
			min = LEConverter.IntFrom(5, response);
			max = LEConverter.IntFrom(9, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletVoltageCurrent.VoltageReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the voltage is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the voltage is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the voltage is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the voltage is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetVoltageCallbackThreshold(char option, int min, int max)
		{
			byte[] data_ = new byte[13];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)13, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 9, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletVoltageCurrent.SetVoltageCallbackThreshold"/>.
		/// </summary>
		public void GetVoltageCallbackThreshold(out char option, out int min, out int max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD, out response);

			option = LEConverter.CharFrom(4, response);
			min = LEConverter.IntFrom(5, response);
			max = LEConverter.IntFrom(9, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletVoltageCurrent.PowerReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the power is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the power is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the power is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the power is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetPowerCallbackThreshold(char option, int min, int max)
		{
			byte[] data_ = new byte[13];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_POWER_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)13, 2, data_);
			LEConverter.To(option, 4, data_);
			LEConverter.To(min, 5, data_);
			LEConverter.To(max, 9, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletVoltageCurrent.SetPowerCallbackThreshold"/>.
		/// </summary>
		public void GetPowerCallbackThreshold(out char option, out int min, out int max)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_POWER_CALLBACK_THRESHOLD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_POWER_CALLBACK_THRESHOLD, out response);

			option = LEConverter.CharFrom(4, response);
			min = LEConverter.IntFrom(5, response);
			max = LEConverter.IntFrom(9, response);
		}

		/// <summary>
		///  Sets the period in ms with which the threshold callbacks
		///  
		///   <see cref="Tinkerforge.BrickletVoltageCurrent.CurrentReached"/>, <see cref="Tinkerforge.BrickletVoltageCurrent.VoltageReached"/>, <see cref="Tinkerforge.BrickletVoltageCurrent.PowerReached"/>
		///  
		///  are triggered, if the thresholds
		///  
		///   <see cref="Tinkerforge.BrickletVoltageCurrent.SetCurrentCallbackThreshold"/>, <see cref="Tinkerforge.BrickletVoltageCurrent.SetVoltageCallbackThreshold"/>, <see cref="Tinkerforge.BrickletVoltageCurrent.SetPowerCallbackThreshold"/>
		///  
		///  keep being reached.
		///  
		///  The default value is 100.
		/// </summary>
		public void SetDebouncePeriod(uint debounce)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(debounce, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletVoltageCurrent.SetDebouncePeriod"/>.
		/// </summary>
		public uint GetDebouncePeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_DEBOUNCE_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_DEBOUNCE_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetCurrent(out int current)
		{
			current = GetCurrent();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetVoltage(out int voltage)
		{
			voltage = GetVoltage();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetPower(out int power)
		{
			power = GetPower();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetCurrentCallbackPeriod(out uint period)
		{
			period = GetCurrentCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetVoltageCallbackPeriod(out uint period)
		{
			period = GetVoltageCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetPowerCallbackPeriod(out uint period)
		{
			period = GetPowerCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetDebouncePeriod(out uint debounce)
		{
			debounce = GetDebouncePeriod();
		}

		internal int CallbackCurrent(byte[] data_)
		{
			int current = LEConverter.IntFrom(4, data_);

			((Current)callbacks[CALLBACK_CURRENT])(current);
			return 8;
		}

		internal int CallbackVoltage(byte[] data_)
		{
			int voltage = LEConverter.IntFrom(4, data_);

			((Voltage)callbacks[CALLBACK_VOLTAGE])(voltage);
			return 8;
		}

		internal int CallbackPower(byte[] data_)
		{
			int power = LEConverter.IntFrom(4, data_);

			((Power)callbacks[CALLBACK_POWER])(power);
			return 8;
		}

		internal int CallbackCurrentReached(byte[] data_)
		{
			int current = LEConverter.IntFrom(4, data_);

			((CurrentReached)callbacks[CALLBACK_CURRENT_REACHED])(current);
			return 8;
		}

		internal int CallbackVoltageReached(byte[] data_)
		{
			int voltage = LEConverter.IntFrom(4, data_);

			((VoltageReached)callbacks[CALLBACK_VOLTAGE_REACHED])(voltage);
			return 8;
		}

		internal int CallbackPowerReached(byte[] data_)
		{
			int power = LEConverter.IntFrom(4, data_);

			((PowerReached)callbacks[CALLBACK_POWER_REACHED])(power);
			return 8;
		}

		/// <summary>
		///  Registers a callback function.
		/// </summary>
		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(Current))
			{
				callbacks[CALLBACK_CURRENT] = d;
			}
			else if(d.GetType() == typeof(Voltage))
			{
				callbacks[CALLBACK_VOLTAGE] = d;
			}
			else if(d.GetType() == typeof(Power))
			{
				callbacks[CALLBACK_POWER] = d;
			}
			else if(d.GetType() == typeof(CurrentReached))
			{
				callbacks[CALLBACK_CURRENT_REACHED] = d;
			}
			else if(d.GetType() == typeof(VoltageReached))
			{
				callbacks[CALLBACK_VOLTAGE_REACHED] = d;
			}
			else if(d.GetType() == typeof(PowerReached))
			{
				callbacks[CALLBACK_POWER_REACHED] = d;
			}
		}
	}
}
